package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class COBTEST4_RVL_REC {
    public @Getter @Builder.Default String RVL_CONT_NO = StringUtils.repeat(
            ' ', 13);
    public @Getter @Builder.Default String RVL_IITEM = StringUtils.repeat(' ',
            5);
    public @Getter @Builder.Default String RVL_IITEM_GB = StringUtils.repeat(
            ' ', 2);
    public @Getter @Builder.Default String RVL_LCYM = StringUtils
            .repeat(' ', 6);
    public @Getter @Setter int RVL_LPMT;
    private final static BiFunction<Long, String, String> intFormatWithoutSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.setNegativePrefix("");
        nf.applyPattern(format);
        return nf.format(value);
    };

    public void setRVL_CONT_NO(String source) {
        RVL_CONT_NO = StringUtils
                .truncate(StringUtils.rightPad(source, 13), 13);
    }

    public void setRVL_IITEM(String source) {
        RVL_IITEM = StringUtils.truncate(StringUtils.rightPad(source, 5), 5);
    }

    public void setRVL_IITEM_GB(String source) {
        RVL_IITEM_GB = StringUtils.truncate(StringUtils.rightPad(source, 2), 2);
    }

    public void setRVL_LCYM(String source) {
        RVL_LCYM = StringUtils.truncate(StringUtils.rightPad(source, 6), 6);
    }

    public String getStringRVL_LPMT() {
        return intFormatWithoutSign.apply((long) RVL_LPMT, "00000");
    }

    public String getRVL_KEY() {
        return RVL_CONT_NO + RVL_IITEM + RVL_IITEM_GB;
    }

    @Override
    public String toString() {
        return getRVL_CONT_NO() + getRVL_IITEM() + getRVL_IITEM_GB()
                + getRVL_LCYM() + getStringRVL_LPMT();
    }
}
